#!/usr/bin/python -u
# -*- mode:python; coding:utf-8; tab-width:4 -*-

import sys
import threading
import Ice
Ice.loadSlice('-I {} cannon.ice'.format(Ice.getSliceDir()))
import Cannon
import math
from matrix_utils import (matrix_horizontal_shift,
                          matrix_vertical_shift,
                          matrix_split, matrix_join)


class FrontendI(Cannon.Frontend):
    def __init__(self, processors):
        self.processors=processors
		self.nProcessors=len(self.processors)
		self.order = int(math.sqrt(self.nProcessors))
		self.proxy=None
		self.colector=None
	
	def CambiarCollector(self, collector):
		self.proxy=collector
	

	def multiply(self, A, B, current=None):

		self.init_processors()
        self.load_processors(A, B)
        #debe devolver una matriz asi que para esta entrega se devolvera una cualquiera
		M=Cannon.Matrix(4, [1,2,3,4,
					5,6,7,8,
					9,10,11,12,
					13,14,15,16])
		return M

    def init_processors(self):
		
		cont=-1
		for i in range(0, self.order):
			for j in range(0, self.order):
				cont=cont+1
				above = ((i+self.order-1)%self.order)*self.order + j
				left = i*self.order + (j+self.order-1)%self.order
				self.processors[i*self.order+j].init(cont, self.order, self.processors[above], self.processors[left], self.proxy)

    def load_processors(self, A, B):
		orderBloque = int(A.ncols/self.order)
		
		matrizDesplazadaA = matrix_horizontal_shift(A, orderBloque)
		bloquesA = matrix_split(matrizDesplazadaA, orderBloque)
		
		matrizDesplazadaB = matrix_vertical_shift(B, orderBloque)
		bloquesB = matrix_split(matrizDesplazadaB, orderBloque)

		for i in range(0, self.nProcessors):
			self.processors[i].injectA(bloquesA[i],0)
			self.processors[i].injectB(bloquesB[i],0)


class CollectorI(Cannon.Collector):
    def __init__(self, order):
		pass


    def inject(self, index, block, current=None):
		pass


class Server(Ice.Application):
    def run(self, args):
        processors = []
		for i in range(0,4):
			proxypr = self.communicator().stringToProxy(args[i+2])
			processors.append(Cannon.ProcessorPrx.checkedCast(proxypr))
        print('found {} processors'.format(len(processors)))
		#pasar el colector e invocar una funcion setColector
        servant = FrontendI(processors)
		
		proxyco = self.communicator().stringToProxy(args[1])
			
		collector = Cannon.CollectorPrx.checkedCast(proxyco)
		servant.CambiarCollector(collector)
        broker = self.communicator()
        adapter = broker.createObjectAdapter('FrontendAdapter')
        proxy = adapter.add(servant, broker.stringToIdentity("frontend"))

        print(proxy)

        adapter.activate()
        self.shutdownOnInterrupt()
        broker.waitForShutdown()


if __name__ == '__main__':
    sys.exit(Server().main(sys.argv))
