#!/usr/bin/python
# -*- mode:python; coding:utf-8; tab-width:4 -*-

import sys

import Ice
Ice.loadSlice('-I {} cannon.ice'.format(Ice.getSliceDir()))
import Cannon
from matrix_utils import (matrix_multiply, sumarMatrices)

class ProcessorI(Cannon.Processor):
    def init(self, index, order, above, left, target, current=None):
        self.index=index
		self.order=order
		self.above=above
		self.left=left
		self.target=target
		self.MatrizA = [None] * order
		self.MatrizB = [None] * order
		self.Resultado = None
		self.suma = None
		self.nPasos = 0
		self.pasosMaximos = order
	

    def injectA(self, A, step, current=None):
		self.MatrizA[step] = A
		
		if(hasattr(self.MatrizB[step],"data")):
			self.multiplicar(step)

    def injectB(self, B, step, current=None):
		self.MatrizB[step] = B

		if(hasattr(self.MatrizA[step],"data")):
			self.multiplicar(step)

	def multiplicar(self, step):
		self.Resultado=matrix_multiply(self.MatrizA[step], self.MatrizB[step])
		if (self.suma == None) :
			self.suma = self.Resultado
		else:
			self.suma = sumarMatrices(self.suma, self.Resultado)
		
		self.nPasos += 1
		
		if (step < (self.pasosMaximos - 1)):
			self.left.injectA(self.MatrizA[step], step+1)
			self.above.injectB(self.MatrizB[step], step+1)
		if (self.nPasos == self.pasosMaximos):
			self.target.inject(self.index,self.suma)


class Server(Ice.Application):
    def run(self, args):
        broker = self.communicator()
        servant = ProcessorI()

        adapter = broker.createObjectAdapter('ProcessorAdapter')
        proxy = adapter.addWithUUID(servant)

        print('processor ready: "{}"'.format(proxy))

        adapter.activate()
        self.shutdownOnInterrupt()
        broker.waitForShutdown()


if __name__ == '__main__':
    app = Server()
    sys.exit(app.main(sys.argv))
